diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/art.c tin-2.6.5/src/art.c
--- tin-2.6.4/src/art.c	2024-12-21 17:43:55.000000000 +0100
+++ tin-2.6.5/src/art.c	2025-12-18 19:57:23.664352406 +0100
@@ -3,10 +3,10 @@
  *  Module    : art.c
  *  Author    : I.Lea & R.Skrenta
  *  Created   : 1991-04-01
- *  Updated   : 2024-12-21
+ *  Updated   : 2025-12-18
  *  Notes     :
  *
- * Copyright (c) 1991-2025 Iain Lea <iain@bricbrac.de>, Rich Skrenta <skrenta@pbm.com>
+ * Copyright (c) 1991-2026 Iain Lea <iain@bricbrac.de>, Rich Skrenta <skrenta@pbm.com>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -51,21 +51,28 @@
 #	include "stpwatch.h"
 #endif /* !STPWATCH_H */
 
-#if defined(USE_ZLIB) && defined(CPP_DOES_CONCAT)
+#ifdef USE_ZLIB
 #	include <zlib.h>
-/* (read)/write data in gzip format (RFC 1952) */
-#	define FPRINTF	gzprintf
-#	define GFP(x)	g ## x
-#else
-#	define FPRINTF	fprintf
-#	define GFP(x)	x
-#endif /* USE_ZLIB && CPP_DOES_CONCAT */
+/*#	if defined(ZLIB_VERNUM) && (ZLIB_VERNUM <= 0xdeef) */ /* once fixed upstream */
+	/*
+	 * redefine Z_NULL to avoid -Wzero-as-null-pointer-constant
+	 * -Wnon-pointer-null warnings
+	 */
+#	undef Z_NULL
+#	define Z_NULL NULL
+/*#	endif *//* ZLIB_VERNUM && ZLIB_VERNUM < 0xdeef */
+#	if defined(ZLIB_VERNUM) && (ZLIB_VERNUM >= 0x1235)
+#	else /* new in 1.2.3.5 */
+#		define gzclose_r gzclose
+#		define gzclose_w gzclose
+#	endif /* ZLIB_VERNUM && ZLIB_VERNUM >= 0x1235 */
+#endif /* USE_ZLIB */
 
 
 /*
  * TODO: fixup to remove CURR_GROUP dependency in all sort funcs
  */
-#define SortBy(func)	tin_sort(arts, (size_t) top_art, sizeof(struct t_article), func);
+#define SortBy(func)	tin_sort(arts, (size_t) top_art, sizeof(struct t_article), func)
 
 int top_art = 0;				/* # of articles in arts[] */
 
@@ -75,7 +82,6 @@ int top_art = 0;				/* # of articles in
 static FILE *open_art_header(const char *groupname, t_artnum art, t_artnum *next);
 static FILE *open_xover_fp(const struct t_group *group, const char *mode, t_artnum min, t_artnum max, t_bool local);
 static char *find_nov_file(const struct t_group *group, int mode);
-static char *print_from(const struct t_group *group, struct t_article *article, int charset);
 static int artnum_comp(t_comptype p1, t_comptype p2);
 static int base_comp(t_comptype p1, t_comptype p2);
 static int date_comp_asc(t_comptype p1, t_comptype p2);
@@ -88,7 +94,7 @@ static int last_date_comp_base_desc(t_co
 static int lines_comp_asc(t_comptype p1, t_comptype p2);
 static int lines_comp_desc(t_comptype p1, t_comptype p2);
 static int read_art_headers(const struct t_group *group, int total, t_artnum top);
-static int read_overview(struct t_group *group, t_artnum min, t_artnum max, t_artnum *top, t_bool local, t_bool *rebuild_cache);
+static int read_overview(struct t_group *group, t_artnum min, t_artnum max, t_artnum *top, t_bool local, t_bool *rebuild_cache, t_bool flag);
 static int score_comp_asc(t_comptype p1, t_comptype p2);
 static int score_comp_desc(t_comptype p1, t_comptype p2);
 static int score_comp_base(t_comptype p1, t_comptype p2);
@@ -101,11 +107,11 @@ static t_bool parse_headers(FILE *fp, st
 static t_compfunc eval_sort_arts_func(unsigned int sort_art_type);
 static time_t get_last_posting_date(t_artnum n);
 static void build_mailbox_list(struct t_article *art, const char *hdr);
+static void sort_arts(unsigned int sort_art_type);
 static void sort_base(unsigned int sort_threads_type);
 static void thread_by_multipart(void);
 static void thread_by_percentage(unsigned int percentage);
 static void thread_by_subject(void);
-static void write_overview(struct t_group *group);
 #ifdef NNTP_ABLE
 	static struct t_article_range *build_range_list(t_artnum min, t_artnum max, int *range_cnt);
 	static t_bool get_path_header(int cur, int cnt, const struct t_group *group, t_artnum min, t_artnum max);
@@ -121,7 +127,9 @@ void
 show_art_msg(
 	const char *group)
 {
-	wait_message(0, _(txt_group), cCOLS - (strwidth(_(txt_group)) > cCOLS ? cCOLS : strwidth(_(txt_group)) + 2 - 3), group);
+	int n = strwidth(_(txt_group));
+
+	wait_message(0, _(txt_group), cCOLS - (n > cCOLS ? cCOLS : n + 2 - 3), group);
 }
 
 
@@ -229,81 +237,45 @@ setup_hard_base(
 #ifdef NNTP_ABLE
 		char buf[NNTP_STRLEN];
 		char line[NNTP_STRLEN];
-		int getart_limit = (cmdline.args & CMDLINE_GETART_LIMIT) ? cmdline.getart_limit : tinrc.getart_limit;
+		int getart_limit = getart_limit_set_from_scope(group) ? group->attribute->getart_limit : (cmdline.args & CMDLINE_GETART_LIMIT) ? cmdline.getart_limit : tinrc.getart_limit;
 		FILE *fp;
 		t_artnum last, start, count = T_ARTNUM_CONST(0), j = T_ARTNUM_CONST(0);
 		static t_bool skip_listgroup = FALSE;
 
-		if (newsrc_active && !list_active)
+		if (!skip_listgroup && ((newsrc_active && !list_active) || !nntp_caps.listgroup))
 			skip_listgroup = TRUE;
 
+		if (getart_limit > 0)
+			j = group->xmax - getart_limit;
+		if (getart_limit < 0)
+			j = getart_limit + find_first_unread(group);
+		if (j < group->xmin)
+			j = group->xmin;
+
 		/*
-		 * Some nntp servers are broken and need an extra GROUP command
-		 * (reported by reorx@irc.pl). This affects (old?) versions of
-		 * nntpcache, leafnode and SurgeNews. Usually this should not be
-		 * needed.
-		 *
 		 * For getart_limit recheck lowwatermark as at least giganews gives
 		 * very different results for LIST ACTIVE (3 year retention for all)
 		 * and GROUP (based on the clients contract).
 		 * Calculate range and prepare base[] not to lose unread arts.
 		 */
-		if (nntp_caps.broken_listgroup || (!skip_listgroup && getart_limit && nntp_caps.type == CAPABILITIES && nntp_caps.reader)) {
-			snprintf(buf, sizeof(buf), "GROUP %s", group->name);
-			if (nntp_command(buf, OK_GROUP, line, sizeof(line)) == NULL)
-				return -1;
-
-			if (sscanf(line, "%"T_ARTNUM_SFMT" %"T_ARTNUM_SFMT, &count, &start) != 2)
-				return -1;
-
-			if (getart_limit > 0) {
-				j = group->xmax - getart_limit;
-				count = MAX(find_first_unread(group), start);
-			}
-			if (getart_limit < 0) {
-				j = getart_limit + find_first_unread(group);
-				count = group->xmin;
-			}
-			if (j < group->xmin)
-				j = group->xmin;
-
-			for (; count < j; count++) {
-				if (grpmenu.max >= max_base)
-					expand_base();
-				base[grpmenu.max++] = count;
-			}
-		}
-
-		/*
-		 * See if LISTGROUP works
-		 */
-		if (!skip_listgroup && getart_limit != 0) { /* try to avoid traffic */
-			if (nntp_caps.type == CAPABILITIES && nntp_caps.reader) {
-				/* RFC 3977 allows ranges in LISTGROUP */
-				if (getart_limit > 0)
-					snprintf(buf, sizeof(buf), "LISTGROUP %s %"T_ARTNUM_PFMT"-%"T_ARTNUM_PFMT"", group->name, j, group->xmax);
-				else /* getart_limit < 0; fetch till newest art */
-					snprintf(buf, sizeof(buf), "LISTGROUP %s %"T_ARTNUM_PFMT"-", group->name, j);
-
-			} else /* for RFC 977 just use GROUP */
-				skip_listgroup = TRUE;
-
-		} else /* get all article numbers */
-			snprintf(buf, sizeof(buf), "LISTGROUP %s", group->name);
-
 		if (!skip_listgroup) {
+			if (getart_limit != 0 && nntp_caps.type == CAPABILITIES && nntp_caps.reader) /* RFC 3977 allows ranges in LISTGROUP */
+				snprintf(buf, sizeof(buf), "LISTGROUP %s %"T_ARTNUM_PFMT"-", group->name, j); /* shorthand for j "-" group->xmax */
+			else
+				snprintf(buf, sizeof(buf), "LISTGROUP %s", group->name);
+
 			if ((fp = nntp_command(buf, OK_GROUP, NULL, 0)) != NULL) {
 				char *ptr;
 
 #	ifdef DEBUG
 				if ((debug & DEBUG_NNTP) && verbose > 1)
-					debug_print_file("NNTP", "setup_hard_base(%s)", buf);
+					debug_print_file("NNTP", "setup_hard_base(LISTGROUP %s)", buf);
 #	endif /* DEBUG */
 
 				while ((ptr = tin_fgets(fp, FALSE)) != NULL) {
 #	ifdef DEBUG
-				if ((debug & DEBUG_NNTP) && verbose)
-					debug_print_file("NNTP", "<<<%s%s", logtime(), ptr);
+					if ((debug & DEBUG_NNTP) && verbose)
+						debug_print_file("NNTP", "<<<%s%s", logtime(), ptr);
 #	endif /* DEBUG */
 					if (grpmenu.max >= max_base)
 						expand_base();
@@ -322,7 +294,7 @@ setup_hard_base(
 				skip_listgroup = TRUE;
 		}
 
-		if (skip_listgroup) { /* LISTGROUP was skipped or failed */
+		if (skip_listgroup || (newsrc_active && list_active)) { /* LISTGROUP was skipped or failed or -ln */
 			/*
 			 * Handle the obscure case that the user aborted before the LISTGROUP
 			 * had a chance to respond
@@ -331,7 +303,7 @@ setup_hard_base(
 				return -1;
 
 			snprintf(buf, sizeof(buf), "GROUP %s", group->name);
-			if (nntp_command(buf, OK_GROUP, line, sizeof(line)) == NULL)
+			if (new_nntp_command(buf, OK_GROUP, line, sizeof(line)) != OK_GROUP)
 				return -1;
 
 			if (sscanf(line, "%"T_ARTNUM_SFMT" %"T_ARTNUM_SFMT" %"T_ARTNUM_SFMT, &count, &start, &last) != 3)
@@ -339,23 +311,25 @@ setup_hard_base(
 
 #	ifdef DEBUG
 			if ((debug & DEBUG_NNTP) && verbose > 1)
-				debug_print_file("NNTP", "setup_hard_base(%s)", buf);
+				debug_print_file("NNTP", "setup_hard_base(GROUP %s %d-%d (%d))", buf, start, last, count);
 #	endif /* DEBUG */
+
 			total = count;
 			grpmenu.max = 0;
-			if (getart_limit > 0) {
+
+			if (getart_limit > 0 && group->xmax > getart_limit) {
 				if ((j = find_first_unread(group)) > start) {
-					if (group->xmax > getart_limit) {
-						start = MIN(j, group->xmax - getart_limit);
-						total = getart_limit;
-					} else
-						start = j;
+					start = MIN(j, group->xmax - getart_limit);
+					total = getart_limit;
 				}
 			}
+
 			if (getart_limit < 0) {
 				if ((j = (getart_limit + find_first_unread(group))) > start)
-					start = j;
+					if (j < group->xmax)
+						start = j;
 			}
+
 			while (start <= last) {
 				if (grpmenu.max >= max_base)
 					expand_base();
@@ -413,11 +387,17 @@ setup_hard_base(
  * the index by looking at the articles in the spool directory,
  * and attempt to write a new index if necessary.
  *
+ * a flag indicates if article headers shall be decoded and
+ * articles shoukd be sorted and put in threads (TRUE) or
+ * we're just interested in the raw data (to write the
+ * cache or the like) (FALSE).
+ *
  * Returns FALSE if the user aborted the indexing, otherwise TRUE
  */
 t_bool
 index_group(
-	struct t_group *group)
+	struct t_group *group,
+	t_bool flag)
 {
 	int i;
 	int changed;				/* Count of articles whose overview has changed */
@@ -427,8 +407,7 @@ index_group(
 	t_artnum last_read_article;
 	t_artnum min, new_min, max;
 	t_bool caching_xover;
-	t_bool filtered;
-	t_bool path_in_nov = FALSE;
+	t_bool filtered = FALSE;
 	t_bool rebuild_cache = FALSE;
 
 	if (group == NULL)
@@ -463,31 +442,29 @@ index_group(
 	}
 #endif /* DEBUG */
 
-	min = grpmenu.max ? base[0] : group->xmin;
+	min = group->xmin;
 	max = grpmenu.max ? base[grpmenu.max - 1] : min - 1;
 
-	getart_limit = (cmdline.args & CMDLINE_GETART_LIMIT) ? cmdline.getart_limit : tinrc.getart_limit;
+	/*
+	 * Quit now if no articles
+	 */
+	if (max < 0)
+		return FALSE;
+
+	getart_limit = getart_limit_set_from_scope(group) ? group->attribute->getart_limit : (cmdline.args & CMDLINE_GETART_LIMIT) ? cmdline.getart_limit : tinrc.getart_limit;
 
 	if (getart_limit > 0) {
 		if (grpmenu.max && (grpmenu.max > getart_limit))
 			min = base[grpmenu.max - getart_limit];
-		else
-			getart_limit = 0;
-	} else if (getart_limit < 0) {
-		t_artnum first_unread = find_first_unread(group);
+	} else {
+		if (getart_limit < 0) {
+			t_artnum first_unread = find_first_unread(group);
 
-		if (min - first_unread < getart_limit)
-			min = first_unread + getart_limit;
-		else
-			getart_limit = 0;
+			if (min - first_unread <= getart_limit)
+				min = first_unread + getart_limit;
+		}
 	}
 
-	/*
-	 * Quit now if no articles
-	 */
-	if (max < 0)
-		return FALSE;
-
 	top_art = 0;
 	last_read_article = T_ARTNUM_CONST(0);
 
@@ -499,8 +476,8 @@ index_group(
 	 * When reading local spool, this will pull in the system wide overview
 	 * cache (if found) otherwise the private overview cache will be read
 	 */
-	caching_xover = (tinrc.cache_overview_files && nntp_caps.over_cmd && group->type == GROUP_TYPE_NEWS);
-	if ((changed = read_overview(group, min, max, &last_read_article, caching_xover, &rebuild_cache)) == -1)
+	caching_xover = (serverrc.cache_overview_files && nntp_caps.over_cmd && group->type == GROUP_TYPE_NEWS);
+	if ((changed = read_overview(group, min, max, &last_read_article, caching_xover, &rebuild_cache, flag)) == -1)
 		return FALSE;	/* user aborted indexing */
 
 	/*
@@ -510,7 +487,7 @@ index_group(
 	if ((last_read_article < max) && caching_xover) {
 		new_min = (last_read_article >= min) ? last_read_article + 1 : min;
 
-		if ((i = read_overview(group, new_min, max, &last_read_article, FALSE, &rebuild_cache)) == -1)
+		if ((i = read_overview(group, new_min, max, &last_read_article, FALSE, &rebuild_cache, flag)) == -1)
 			return FALSE;	/* user aborted indexing */
 		else
 			changed += i;
@@ -528,6 +505,7 @@ index_group(
 		}
 		if (base[i] <= last_read_article)		/* It is vital this test be done last */
 			continue;
+
 		++total;
 	}
 
@@ -576,8 +554,6 @@ index_group(
 			if (group->attribute && group->attribute->show_only_unread_arts)
 				arts[i].keep_in_base = FALSE;
 		}
-		if (!path_in_nov && arts[i].path && *arts[i].path != '\0')
-			path_in_nov = TRUE;
 	}
 
 	/*
@@ -587,27 +563,40 @@ index_group(
 	if (changed || caching_xover || rebuild_cache)
 		write_overview(group);
 
+	if (flag) {
+		/*
+		 * The articles are currently unsorted, and are as they
+		 * were put by setup_hard_base()
+		 */
+		BegStopWatch();
+		if (group->attribute && group->attribute->sort_article_type != SORT_ARTICLES_BY_NOTHING)
+			sort_arts(group->attribute->sort_article_type);
+		EndStopWatch("sort_arts()");
+	}
+
 	/*
 	 * Create the reference tree. The msgid and ref ptrs will
 	 * be free()d now that the NovFile has been written.
 	 */
 	BegStopWatch();
-	build_references(group);
+	build_references();
 	EndStopWatch("build_references()");
 
-	/*
-	 * Needs access to the reference tree
-	 */
-	BegStopWatch();
-	filtered = filter_articles(group);
-	EndStopWatch("filter_articles()");
+	if (flag) {
+		/*
+		 * Needs access to the reference tree
+		 */
+		BegStopWatch();
+		filtered = filter_articles(group);
+		EndStopWatch("filter_articles()");
 
-	/*
-	 * Thread the group
-	 */
-	BegStopWatch();
-	make_threads(group, FALSE);
-	EndStopWatch("make_threads()");
+		/*
+		 * Thread the group
+		 */
+		BegStopWatch();
+		make_threads(group, FALSE);
+		EndStopWatch("make_threads()");
+	}
 
 	if ((changed > 0 || filtered) && !batch_mode)
 		clear_message();
@@ -652,8 +641,13 @@ open_art_header(
 
 #ifdef NNTP_ABLE
 	if (read_news_via_nntp && CURR_GROUP.type == GROUP_TYPE_NEWS) {
+#if 0
 		FILE *fp;
-		static t_bool no_next = FALSE; /* TODO: move to t_capabilities ? */
+#endif /* 0 */
+		static t_bool no_next = FALSE;
+
+		if (!no_next && strstr(serverrc.disabled_nntp_cmds, "NEXT") != NULL)
+			no_next = TRUE;
 		/*
 		 * Don't bother requesting if we have not got there yet.
 		 * This is a big win if the group has got holes in it (ie. if 000's
@@ -663,18 +657,30 @@ open_art_header(
 			return NULL;
 
 		snprintf(buf, sizeof(buf), "HEAD %"T_ARTNUM_PFMT, art);
+#if 0
 		if ((fp = nntp_command(buf, OK_HEAD, NULL, 0)) != NULL)
 			return fp;
+#else
+		switch(new_nntp_command(buf, OK_HEAD, NULL, 0)) {
+			case OK_HEAD:
+				return FAKE_NNTP_FP;
+				/* NOTREACHED */
+				break;
 
-		/*
-		 * TODO:
-		 * shall we stop on 5xx?, i.e JamNNTPd/2 1.3 responds with
-		 * "503 Access denied" instead of 480 but NEXT still works,
-		 * so tin loops over all articles without getting useful data
-		 *
-		 * usenet.farm may return ERR_GOODBYE and NEXT then also fails
-		 * we could flag that like no_next ...
-		 */
+			case ERR_FAULT:		/* JamNNTPd/2 1.3 */
+			case ERR_GOODBYE:	/* usenet.farm */
+			case ERR_NOART:		/* usenet.farm */
+				no_next = TRUE;
+				return NULL;
+				/* NOTREACHED */
+				break;
+
+			/* do we need case ERR_NCING: to send GROUP here? */
+
+			default:
+				break;
+		}
+#endif /* 0 */
 
 		if (!no_next) { /* usenet.farm doesn't do NEXT */
 			/*
@@ -686,23 +692,42 @@ open_art_header(
 					*next = atoartnum(buf);		/* Set next art number */
 					break;
 
-#	ifndef BROKEN_LISTGROUP
 				/*
 				 * might happen if LISTGROUP doesn't select group, but
-				 * we are not -DBROKEN_LISTGROUP
+				 * we do not have disabled_nntp_cmds=LISTGROUP
 				 */
 				case ERR_NCING:
-					nntp_caps.broken_listgroup = TRUE;
+					nntp_caps.listgroup = FALSE;
 					snprintf(buf, sizeof(buf), "GROUP %s", groupname);
-					if (nntp_command(buf, OK_GROUP, NULL, 0) == NULL)
+					if (new_nntp_command(buf, OK_GROUP, NULL, 0) != OK_GROUP)
 						return NULL;
 					snprintf(buf, sizeof(buf), "HEAD %"T_ARTNUM_PFMT, art);
+#if 0
 					if ((fp = nntp_command(buf, OK_HEAD, NULL, 0)) != NULL)
 						return fp;
-					if (nntp_command("NEXT", OK_NOTEXT, buf, sizeof(buf)))
+#else
+					switch(new_nntp_command(buf, OK_HEAD, NULL, 0)) {
+						case OK_HEAD:
+							return FAKE_NNTP_FP;
+							/* NOTREACHED */
+							break;
+
+						case ERR_NCING:		/* we did select the group! */
+						case ERR_NOART:		/* we didn't ask for an id! */
+							no_next = TRUE;
+							return NULL;
+							/* NOTREACHED */
+							break;
+
+						default:
+							break;
+					}
+#endif /* 0 */
+					if (new_nntp_command("NEXT", OK_NOTEXT, buf, sizeof(buf)) == OK_NOTEXT) {
 						*next = atoartnum(buf);
-					break;
-#	endif /* !BROKEN_LISTGROUP */
+						break;
+					}
+					/* FALLTHROUGH */
 
 				case ERR_COMMAND:	/* TODO: abort loop over all arts */
 					no_next = TRUE;
@@ -716,27 +741,22 @@ open_art_header(
 					/*
 					 * TODO: abort loop over all arts on ERR_NONEXT
 					 */
-#	ifndef BROKEN_LISTGROUP
 					/*
 					 * to avoid out of sync responses
-					 * (listgroup seems to work, but didn't select new group,
+					 * (LISTGROUP seems to work, but didn't select new group,
 					 *  so xover seems to work but returns old data)
 					 * we set listgroup_broken = TRUE; once we saw a
 					 * ERR_NOARTIG / ERR_NONEXT or the like - even if
-					 * ERR_NOARTIG may occur on servers where listgroup
+					 * ERR_NOARTIG may occur on servers where LISTGROUP
 					 * isn't broken...
 					 */
-					nntp_caps.broken_listgroup = TRUE;
-#	endif /* !BROKEN_LISTGROUP */
+					nntp_caps.listgroup = FALSE;
 					break;
 			}
 		}
 		return NULL;
 	}
 	/* silence compiler warning (unused parameter) */
-#	ifdef BROKEN_LISTGROUP
-	(void) groupname;
-#	endif /* BROKEN_LISTGROUP */
 #else
 	(void) groupname;
 	(void) next;
@@ -802,9 +822,7 @@ read_art_headers(
 		 * Skip articles that are below the low water mark or are
 		 * already present
 		 */
-		if (valid_artnum(art) >= 0)
-			continue;
-		if (art <= top)
+		if (valid_artnum(art) >= 0 || art <= top)
 			continue;
 
 		/*
@@ -843,7 +861,6 @@ read_art_headers(
 			arts[top_art].artnum = T_ARTNUM_CONST(0);
 			arts[top_art].date = (time_t) 0;
 			FreeAndNull(arts[top_art].xref);
-			FreeAndNull(arts[top_art].path);
 			FreeAndNull(arts[top_art].refs);
 			FreeAndNull(arts[top_art].msgid);
 			free_mailbox_list(arts[top_art].mailbox.next);
@@ -961,6 +978,11 @@ thread_by_percentage(
 	base[0] = 0;
 	arts[0].prev = ART_NORMAL;
 	for_each_art(i) {
+		if (arts[i].refptr == NULL) /* should not happen */
+			continue;
+
+		/* Correct the back references, as art[] has been re-sorted. */
+		arts[i].refptr->article = i;
 		if (i == 0)
 			continue;
 
@@ -1268,9 +1290,11 @@ thread_by_multipart(
  */
 void
 make_threads(
-	struct t_group *group,
+	const struct t_group *group,
 	t_bool rethread)
 {
+	int i;
+
 	if (!cmd_line && !batch_mode) {
 		info_message((group->attribute->thread_articles == THREAD_NONE ? _(txt_unthreading_arts) : _(txt_threading_arts)));
 		my_flush();
@@ -1295,34 +1319,29 @@ make_threads(
 	 */
 	clear_art_ptrs();
 
-	/*
-	 * The threading pointers need to be reset if re-threading
-	 * If using ref threading, revector the links back to the articles
-	 */
-	if (rethread || (group->attribute && group->attribute->thread_articles)) {
-		int i;
-
-		for_each_art(i) {
+	for_each_art(i) {
+		/* The threading pointers need to be reset if re-threading */
+		if (rethread || (group->attribute && group->attribute->thread_articles)) {
 			if (arts[i].thread >= 0)
 				arts[i].thread = ART_UNTHREADED;
 
 			arts[i].prev = ART_NORMAL;
+		}
 
-			/* Should never happen if tree is built properly */
-			if (arts[i].refptr == NULL) {
+		/* Should never happen if tree is built properly */
+		if (arts[i].refptr == NULL) {
 #ifdef DEBUG
-				if (debug & DEBUG_REFS) {
-					my_fprintf(stderr, "\nError  : art->refptr is NULL\n");
-					my_fprintf(stderr, "Artnum : %"T_ARTNUM_PFMT"\n", arts[i].artnum);
-					my_fprintf(stderr, "Subject: %s\n", arts[i].subject);
-					my_fprintf(stderr, "From   : %s\n", arts[i].mailbox.from);
-					assert(arts[i].refptr != NULL);
-				} else
+			if (debug & DEBUG_REFS) {
+				my_fprintf(stderr, "\nError  : art->refptr is NULL\n");
+				my_fprintf(stderr, "Artnum : %"T_ARTNUM_PFMT"\n", arts[i].artnum);
+				my_fprintf(stderr, "Subject: %s\n", arts[i].subject);
+				my_fprintf(stderr, "From   : %s\n", arts[i].mailbox.from);
+				assert(arts[i].refptr != NULL);
+			} else
 #endif /* DEBUG */
-					continue;
-			}
-			arts[i].refptr->article = i;
+				continue;
 		}
+		arts[i].refptr->article = i;
 	}
 
 	/*
@@ -1409,7 +1428,7 @@ eval_sort_arts_func(
 }
 
 
-void
+static void
 sort_arts(
 	unsigned int sort_art_type)
 {
@@ -1492,6 +1511,8 @@ parse_headers(
 			case 'F':	/* From:  mandatory */
 				if (!got_from) {
 					if ((hdr = parse_header(ptr + 1, "rom", FALSE, FALSE, FALSE))) {
+						if (serverrc.cache_overview_files)
+							h->from_raw = hash_str(hdr);
 						build_mailbox_list(h, hdr);
 						got_from = TRUE;
 					}
@@ -1518,7 +1539,7 @@ parse_headers(
 			case 'P':	/* Path: */
 				if (!h->path) {
 					if ((hdr = parse_header(ptr + 1, "ath", FALSE, FALSE, FALSE)))
-						h->path = my_strdup(hdr);
+						h->path = hash_str(hdr);
 				}
 				break;
 
@@ -1532,6 +1553,8 @@ parse_headers(
 			case 'S':	/* Subject:  mandatory */
 				if (!h->subject) {
 					if ((hdr = parse_header(ptr + 1, "ubject", FALSE, FALSE, FALSE))) {
+						if (serverrc.cache_overview_files && !h->subject_raw)
+							h->subject_raw = hash_str(hdr);
 #ifdef HAVE_UNICODE_NORMALIZATION
 						if (IS_LOCAL_CHARSET("UTF-8"))
 							s = normalize(eat_re(convert_to_printable(rfc1522_decode(hdr), FALSE), FALSE));
@@ -1575,7 +1598,12 @@ parse_headers(
 	if (got_from && h->date && h->msgid) {
 		if (!h->subject)
 			h->subject = hash_str("");
-
+		if (serverrc.cache_overview_files) {
+			if (!h->subject_raw)
+				h->subject_raw = hash_str("");
+			if (!h->from_raw)
+				h->from_raw= hash_str("");
+		}
 #ifdef DEBUG
 		if (debug & DEBUG_FILTER)
 			debug_print_header(h);
@@ -1765,7 +1793,7 @@ get_path_header(
 #	endif /* DEBUG */
 
 	if (nntp_caps.type == CAPABILITIES && nntp_caps.list_headers && !*nntp_caps.headers_range && nntp_caps.hdr_cmd[0] != 'X') {
-		switch (new_nntp_command("LIST HEADERS RANGE", 215, cmd, sizeof(cmd))) {
+		switch (new_nntp_command("LIST HEADERS RANGE", 215, NULL, 0)) {
 			case 215:
 				while ((ptr = tin_fgets(FAKE_NNTP_FP, FALSE)) != NULL) {
 #	ifdef DEBUG
@@ -1784,21 +1812,22 @@ get_path_header(
 	}
 
 	/* does HDR return Path? */
-	if (nntp_caps.headers_range && (ptr = strtok(nntp_caps.headers_range, "\n")) != NULL) {
-		do {
-			if ((*ptr == ':' && *(ptr + 1) == '\0') || !strncasecmp(ptr, "Path", 4))
-				found = TRUE;
-		} while (!found && *ptr && (ptr = strtok(NULL, "\n")) != NULL);
-	}
+	if (nntp_caps.type == CAPABILITIES) {
+		if (nntp_caps.headers_range && (ptr = strtok(nntp_caps.headers_range, "\n")) != NULL) {
+			do {
+				if ((*ptr == ':' && *(ptr + 1) == '\0') || !strncasecmp(ptr, "Path", 4))
+					found = TRUE;
+			} while (!found && *ptr && (ptr = strtok(NULL, "\n")) != NULL);
+		}
+	} else
+		found = TRUE;
 
-	if ((nntp_caps.hdr || nntp_caps.hdr_cmd) && (!(nntp_caps.type == CAPABILITIES) || found)) {
+	if (nntp_caps.hdr && nntp_caps.hdr_cmd && found) {
 		if (min == max)
 			snprintf(cmd, sizeof(cmd), "%s Path %"T_ARTNUM_PFMT, nntp_caps.hdr_cmd, min);
 		else
 			snprintf(cmd, sizeof(cmd), "%s Path %"T_ARTNUM_PFMT"-%"T_ARTNUM_PFMT, nntp_caps.hdr_cmd, min, MAX(min, max));
 		fp = nntp_command(cmd, nntp_caps.hdr_cmd[0] == 'X' ? OK_XHDR : OK_HDR, NULL, 0);
-		if (!nntp_caps.hdr && fp)
-			nntp_caps.hdr = TRUE;
 	} else if (nntp_caps.xpat) {
 		if (min == max)
 			snprintf(cmd, sizeof(cmd), "XPAT Path %"T_ARTNUM_PFMT" *", min);
@@ -1808,8 +1837,8 @@ get_path_header(
 	}
 
 	if (fp) {
-		t_artnum artnum, i, j = T_ARTNUM_CONST(0);
 		char *prep_msg = fmt_string(_(txt_prep_for_filter_on_path), cur, cnt);
+		t_artnum artnum, i, j = T_ARTNUM_CONST(0);
 
 		while ((buf = tin_fgets(fp, FALSE)) != NULL && buf[0] != '.') {
 #	ifdef DEBUG
@@ -1823,8 +1852,7 @@ get_path_header(
 				continue;
 			for (i = j; i < top_art; i++) {
 				if (arts[i].artnum == artnum) {
-					FreeIfNeeded(arts[i].path);
-					arts[i].path = my_strdup(ptr);
+					arts[i].path = hash_str(ptr);
 					j = i;
 					break;
 				}
@@ -1959,7 +1987,8 @@ read_overview(
 	t_artnum max,
 	t_artnum *top,
 	t_bool local,
-	t_bool *rebuild_cache)
+	t_bool *rebuild_cache,
+	t_bool flag)
 {
 	FILE *fp;
 	char *ptr;
@@ -1973,8 +2002,9 @@ read_overview(
 	struct t_article *art;
 	size_t over_fields = 1;
 #ifdef USE_ZLIB
-	int fd;
-	gzFile gfp = NULL; /* we don't use Z_NULL here to avoid -Wzero-as-null-pointer-constant */
+	int fd, dup_fd = -1;
+	gzFile gzfp = Z_NULL;
+	struct stat st;
 #endif /* USE_ZLIB */
 
 	/*
@@ -1984,11 +2014,31 @@ read_overview(
 		return expired;
 
 #ifdef USE_ZLIB
-	if (fp != FAKE_NNTP_FP /* && tinrc.compress_overview_files */ ) { /* we may need to read compressed data even if not writing it */
-		fd = fileno(fp);
-		if ((gfp = gzdopen(fd, "r")) != Z_NULL) {
-			buf = my_malloc(32768 + 1);  /* FIXME make dynamic; I've seen up to 8K overview lines in the wild, so 32k should be "safe" */
-			/* gzbuffer(gfp, 4 * 32768); */	/* the 8k default is ok for us */
+	if (fp != FAKE_NNTP_FP) { /* we may need to read compressed data even if not writing it, so no check for serverrc.compress_overview_files */
+		if ((fd = fileno(fp)) == -1) { /* paranoid */
+			fclose(fp);
+			return expired;
+		}
+		if ((dup_fd = dup(fd)) != -1) {
+			if ((gzfp = gzdopen(dup_fd, "r")) == Z_NULL)
+				close(dup_fd);
+			else {
+#	if 0
+				/*
+				 * a benchmark with 5493440 uncompressed overview records
+				 * (~2GB data) didn't show any noticeable time difference,
+				 * so stay with the gzgets() code even for plain data.
+				 */
+				if (gzdirect(gzfp)) { /* not gzipped, use normal read-code to avoid zlib overhead */
+					gzclose_r(gzfp);
+					if (fstat(dup_fd, &st) == 0 || errno != EBADF) /* dup_fd still open? */
+						close(dup_fd);
+					gzfp = Z_NULL;
+					fseek(fp, 0L, SEEK_SET); /* rewind gzdirect() */
+				} else
+#	endif /* 0 */
+					buf = my_malloc(32768 + 1);	/* FIXME make dynamic; I've seen up to 8K overview lines in the wild, so 32k should be "safe" */
+			}
 		}
 	}
 #endif /* USE_ZLIB */
@@ -2031,15 +2081,11 @@ read_overview(
 		over_fields = 7;
 	}
 
-#ifdef USE_ZLIB
 	while (
-		gfp ? gzgets(gfp, buf, 32768) != Z_NULL /* FIXME: don't use fixed size */
-			: (buf = tin_fgets(fp, FALSE)) != NULL
-	)
-#else
-	while ((buf = tin_fgets(fp, FALSE)) != NULL)
+#ifdef USE_ZLIB
+		gzfp ? gzgets(gzfp, buf, 32768) != Z_NULL : /* FIXME: don't use fixed size */
 #endif /* USE_ZLIB */
-	{
+		(buf = tin_fgets(fp, FALSE)) != NULL) {
 
 #if defined(DEBUG) && defined(NNTP_ABLE)
 		if ((debug & DEBUG_NNTP) && fp == FAKE_NNTP_FP && verbose)
@@ -2137,7 +2183,7 @@ read_overview(
 						ofmt[over_fields].name = my_strdup("Path:");
 						ofmt[over_fields + 1].type = OVER_T_ERROR;
 						ofmt[over_fields + 1].name = NULL;
-						xref_supported = TRUE;
+						/* path_in_ofmt = TRUE; */
 					} else
 						continue;
 				} else
@@ -2150,17 +2196,24 @@ read_overview(
 				if (ofmt[count].type == OVER_T_STRING) {
 					if (!strcasecmp(ofmt[count].name, "Subject:")) {
 						if (*ptr) {
+							if (!flag || serverrc.cache_overview_files)
+								art->subject_raw = hash_str(ptr);
+							if (flag) {
 #ifdef HAVE_UNICODE_NORMALIZATION
-							if (IS_LOCAL_CHARSET("UTF-8"))
-								q = normalize(eat_re(eat_tab(convert_to_printable(rfc1522_decode(ptr), FALSE)), FALSE));
-							else
+								if (IS_LOCAL_CHARSET("UTF-8"))
+									q = normalize(eat_re(eat_tab(convert_to_printable(rfc1522_decode(ptr), FALSE)), FALSE));
+								else
 #endif /* HAVE_UNICODE_NORMALIZATION */
-								q = my_strdup(eat_re(eat_tab(convert_to_printable(rfc1522_decode(ptr), FALSE)), FALSE));
+									q = my_strdup(eat_re(eat_tab(convert_to_printable(rfc1522_decode(ptr), FALSE)), FALSE));
 
-							art->subject = hash_str(q);
-							free(q);
+								art->subject = hash_str(q);
+								free(q);
+							}
 						} else {
-							art->subject = hash_str("");
+							if (!flag || serverrc.cache_overview_files)
+								art->subject_raw = hash_str("");
+							if (flag)
+								art->subject = hash_str("");
 #ifdef DEBUG
 							if ((debug & DEBUG_NNTP) && verbose > 1)
 								debug_print_file("NNTP", "%s(%"T_ARTNUM_PFMT") empty overview-field %s", nntp_caps.over_cmd, artnum, ofmt[count].name);
@@ -2170,13 +2223,20 @@ read_overview(
 					}
 
 					if (!strcasecmp(ofmt[count].name, "From:")) {
-						if (*ptr)
-							build_mailbox_list(art, ptr);
-						else {
-							struct t_mailbox *mb;
+						if (*ptr) {
+							if (!flag || serverrc.cache_overview_files)
+								art->from_raw = hash_str(ptr);
+							if (flag)
+								build_mailbox_list(art, ptr);
+						} else {
+							if (!flag || serverrc.cache_overview_files)
+								art->from_raw = hash_str("");
+							if (flag) {
+								struct t_mailbox *mb;
 
-							if ((mb = add_mailbox(art)) != NULL)
-								mb->from = hash_str("");
+								if ((mb = add_mailbox(art)) != NULL)
+									mb->from = hash_str("");
+							}
 #ifdef DEBUG
 							if ((debug & DEBUG_NNTP) && verbose > 1)
 								debug_print_file("NNTP", "%s(%"T_ARTNUM_PFMT") empty overview-field %s", nntp_caps.over_cmd, artnum, ofmt[count].name);
@@ -2234,11 +2294,8 @@ read_overview(
 					if (!strcasecmp(ofmt[count].name, "Path:")) {
 						if (!path_found)
 							path_found = TRUE;
-						if (*ptr) {
-							FreeIfNeeded(art->path); /* if field is listed more than once in overview.fmt */
-							art->path = my_strdup(ptr);
-						} else
-							art->path = NULL;
+						if (*ptr)
+							art->path = hash_str(ptr);
 						continue;
 					}
 				}
@@ -2274,17 +2331,24 @@ read_overview(
 				switch (count) {
 					case 1: /* Subject: */
 						if (*ptr) {
+							if (!flag || serverrc.cache_overview_files)
+								art->subject_raw = hash_str(ptr);
+							if (flag) {
 #ifdef HAVE_UNICODE_NORMALIZATION
-							if (IS_LOCAL_CHARSET("UTF-8"))
-								q = normalize(eat_re(eat_tab(convert_to_printable(rfc1522_decode(ptr), FALSE)), FALSE));
-							else
+								if (IS_LOCAL_CHARSET("UTF-8"))
+									q = normalize(eat_re(eat_tab(convert_to_printable(rfc1522_decode(ptr), FALSE)), FALSE));
+								else
 #endif /* HAVE_UNICODE_NORMALIZATION */
-								q = my_strdup(eat_re(eat_tab(convert_to_printable(rfc1522_decode(ptr), FALSE)), FALSE));
+									q = my_strdup(eat_re(eat_tab(convert_to_printable(rfc1522_decode(ptr), FALSE)), FALSE));
 
-							art->subject = hash_str(q);
-							free(q);
+								art->subject = hash_str(q);
+								free(q);
+							}
 						} else {
-							art->subject = hash_str("");
+							if (!flag || serverrc.cache_overview_files)
+								art->subject_raw = hash_str("");
+							if (flag)
+								art->subject = hash_str("");
 #ifdef DEBUG
 							if ((debug & DEBUG_NNTP) && verbose > 1)
 								debug_print_file("NNTP", "%s(%"T_ARTNUM_PFMT") empty overview-field %s", nntp_caps.over_cmd, artnum, ofmt[count].name);
